VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CPlugin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Implements core.IBasePlugin

Private Declare Sub SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long)
Private Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal uAction As Long, ByVal uParam As Long, ByRef lpvParam As Any, ByVal fuWinIni As Long) As Long
Private Declare Function GetLastError Lib "kernel32" () As Long
Private Type MINIMIZEDMETRICS
    cbSize As Long
    iWidth As Long
    iHorzGap As Long
    iVertGap As Long
    iArrange As Long
End Type
Private Const SPI_GETMINIMIZEDMETRICS = 43
Private Const SPI_SETMINIMIZEDMETRICS = 44
Private Const HWND_TOPMOST = -1
Private Const SWP_NOACTIVATE = &H10
Private Const SWP_SHOWWINDOW = &H40
Private mWndProcOrg As Long
Private mHWndSubClassed As Long
Private m_sName As String
Private m_iArrange As Long
Private m_oForm As tasks.frmPlugin
Const WM_PAINT = &HF
Private Function IBasePlugin_StartPlugin(name As String) As Long
    
    Dim mm As MINIMIZEDMETRICS
    Dim ErrNum As Integer
    
    Set oServer = CreateObject("core.CServer")
    oServer.RegisterBang name, "!refresh"
    oServer.RegisterBang name, "!hide"
    oServer.RegisterBang name, "!show"
    oServer.RegisterBang name, "!toggle"
    
    mm.cbSize = Len(mm)
    ErrNum = SystemParametersInfo(SPI_GETMINIMIZEDMETRICS, Len(mm), mm, 0)
    If ErrNum = 0 Then
        ErrNum = GetLastError
        oServer.Execute "!log tasks - error: Failed Get " & CStr(ErrNum)
    End If
    m_iArrange = mm.iArrange
    mm.iArrange = 8 'mm.iArrange Xor 8
    mm.iWidth = 0
    ErrNum = SystemParametersInfo(SPI_SETMINIMIZEDMETRICS, Len(mm), mm, 0)
    If ErrNum = 0 Then
        ErrNum = GetLastError
        oServer.Execute "!log tasks - error: Failed Set " & CStr(ErrNum)
    End If
    
    m_sName = name
    setup
    
'    SubClass
    IBasePlugin_StartPlugin = m_oForm.hwnd

End Function
Private Sub setup()

    Dim textline As String
    
    Set m_oForm = New tasks.frmPlugin
    Call Load(m_oForm)
    
    m_oForm.Tag = m_sName
    m_oForm.Caption = m_sName
    m_oForm.Left = oServer.evalNum(oServer.GetKey(m_sName, "X")) * Screen.TwipsPerPixelX
    m_oForm.Top = oServer.evalNum(oServer.GetKey(m_sName, "Y")) * Screen.TwipsPerPixelY
    
    m_oForm.picTasks(0).Height = oServer.evalNum(oServer.GetKey(m_sName, "TileHeight"))
    m_oForm.picTasks(0).Width = oServer.evalNum(oServer.GetKey(m_sName, "TileWidth"))
    textline = oServer.GetKey(m_sName, "TileBackground")
    If textline <> "" Then
        m_oForm.picTasks(0).Picture = LoadPicture(textline)
        m_oForm.picTasks(0).Left = -m_oForm.picTasks(0).Width
        m_oForm.Height = m_oForm.picTasks(0).Height * Screen.TwipsPerPixelY
    Else
        oServer.Execute "!log Error: tasks module couldn't find a tile to use when displaying tasks"
    End If
    If oServer.evalBool(oServer.GetKey(m_sName, "AlwaysOnTop")) Then
        SetWindowPos m_oForm.hwnd, HWND_TOPMOST, m_oForm.Left / Screen.TwipsPerPixelX, m_oForm.Top / Screen.TwipsPerPixelY, m_oForm.Width / Screen.TwipsPerPixelX, m_oForm.Height / Screen.TwipsPerPixelY, SWP_NOACTIVATE Or SWP_SHOWWINDOW
    End If
    oServer.transparant m_oForm.hwnd, &HFF00FF
    m_oForm.tmrTasks.Interval = oServer.evalNum(oServer.GetKey(m_sName, "Interval"))
    m_oForm.tmrTasks_Timer
    m_oForm.tmrTasks.Enabled = True
    m_oForm.Show

End Sub
Private Sub IBasePlugin_StopPlugin()

    Dim mm As MINIMIZEDMETRICS
    Dim ErrNum As Integer
    
'    UnSubClass
    m_oForm.Visible = False
    Call Unload(m_oForm)
    Set m_oForm = Nothing
    mm.cbSize = Len(mm)
    ErrNum = SystemParametersInfo(SPI_GETMINIMIZEDMETRICS, Len(mm), mm, 0)
    If ErrNum = 0 Then
        ErrNum = GetLastError
        oServer.Execute "!log tasks - error: Failed Get " & CStr(ErrNum)
    End If
    mm.iArrange = m_iArrange
    mm.iWidth = 0
    ErrNum = SystemParametersInfo(SPI_SETMINIMIZEDMETRICS, Len(mm), mm, 0)
    If ErrNum = 0 Then
        ErrNum = GetLastError
        oServer.Execute "!log tasks - error: Failed Set " & CStr(ErrNum)
    End If

End Sub
Private Sub IBasePlugin_Bang(ByVal name As String, ByVal Arguments As String)
    
    Select Case name
    Case "!refresh"
        If LCase(Arguments) = LCase(m_sName) Or LCase(Arguments) = LCase("*") Then
            m_oForm.Visible = False
            Call Unload(m_oForm)
            Set m_oForm = Nothing
            setup
        End If
    Case "!hide"
        If LCase(Arguments) = LCase(m_sName) Or LCase(Arguments) = LCase("*") Then
            m_oForm.Visible = False
        End If
    Case "!show"
        If LCase(Arguments) = LCase(m_sName) Or LCase(Arguments) = LCase("*") Then
            m_oForm.Visible = True
            If oServer.evalBool(oServer.GetKey(m_sName, "alwaysontop")) Then
                SetWindowPos m_oForm.hwnd, HWND_TOPMOST, m_oForm.Left / Screen.TwipsPerPixelX, m_oForm.Top / Screen.TwipsPerPixelY, m_oForm.Width / Screen.TwipsPerPixelX, m_oForm.Height / Screen.TwipsPerPixelY, SWP_NOACTIVATE Or SWP_SHOWWINDOW
            End If
            m_oForm.Left = oServer.evalNum(oServer.GetKey(m_sName, "x")) * Screen.TwipsPerPixelX
            m_oForm.Top = oServer.evalNum(oServer.GetKey(m_sName, "y")) * Screen.TwipsPerPixelY
        End If
    Case "!toggle"
        If LCase(Arguments) = LCase(m_sName) Or LCase(Arguments) = LCase("*") Then
            m_oForm.Visible = Not m_oForm.Visible
        End If
    End Select


End Sub
Private Property Get IBasePlugin_Name() As String

    IBasePlugin_Name = m_sName

End Property
Public Property Get IBasePlugin_InstanceName() As String

    IBasePlugin_InstanceName = m_sName

End Property
Public Property Get IBasePlugin_PluginName() As String

    IBasePlugin_PluginName = App.Title

End Property
Public Property Get IBasePlugin_Copyright() As String

    IBasePlugin_Copyright = App.LegalCopyright

End Property
Public Property Get IBasePlugin_Version() As String

    IBasePlugin_Version = App.Major & "." & App.Minor

End Property
Public Property Get IBasePlugin_Description() As String

    IBasePlugin_Description = App.FileDescription

End Property
Private Sub SubClass()
   '-------------------------------------------------------------
   'Initiates the subclassing of this UserControl's window (hwnd).
   'Records the original WinProc of the window in mWndProcOrg.
   'Places a pointer to the object in the window's UserData area.
   '-------------------------------------------------------------

   'Exit if the window is already subclassed.
   If mWndProcOrg Then Exit Sub

      'Redirect the window's messages from this control's default
      'Window Procedure to the SubWndProc function in your .BAS
      'module and record the address of the previous Window
      'Procedure for this window in mWndProcOrg.
      mWndProcOrg = SetWindowLong(m_oForm.hwnd, GWL_WNDPROC, AddressOf SubWndProc)

      'Record your window handle in case SetWindowLong gave you a
      'new one. You will need this handle so that you can unsubclass.
      mHWndSubClassed = m_oForm.hwnd

      'Store a pointer to this object in the UserData section of
      'this window that will be used later to get the pointer to
      'the control based on the handle (hwnd) of the window getting
      'the message.
      Call SetWindowLong(m_oForm.hwnd, GWL_USERDATA, ObjPtr(Me))

End Sub
Private Sub UnSubClass()
   
   '-----------------------------------------------------------
   'Unsubclasses this UserControl's window (hwnd), setting the
   'address of the Windows Procedure back to the address it was
   'at before it was subclassed.
   '-----------------------------------------------------------

   'Ensures that you don't try to unsubclass the window when
   'it is not subclassed.
   If mWndProcOrg = 0 Then Exit Sub

   'Reset the window's function back to the original address.
   SetWindowLong mHWndSubClassed, GWL_WNDPROC, mWndProcOrg
   '0 Indicates that you are no longer subclassed.
   mWndProcOrg = 0

End Sub
Friend Function WindowProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   '--------------------------------------------------------------
   'Process the window's messages that are sent to your UserControl.
   'The WindowProc function is declared as a "Friend" function so
   'that the .BAS module can call the function but the function
   'cannot be seen from outside the UserControl project.
   '--------------------------------------------------------------

    Select Case uMsg
        Case WM_PAINT
            oServer.Execute "!log VM_PAINT"
    End Select
   
    'Forwards the window's messages that came in to the original
    'Window Procedure that handles the messages and returns
    'the result back to the SubWndProc function.
    WindowProc = CallWindowProc(mWndProcOrg, m_oForm.hwnd, uMsg, wParam, ByVal lParam)

End Function

